﻿using System; 
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UltraTreeDataBinding
{
    public partial class Form1 : Form
    {
        private bool  IsInit =true;
        private bool IsDuplicate = false;
        private static string OldValue;
        private DataSet ds;

        public Form1()
        {
            InitializeComponent();

            
            ds = new DataSet();


            // To simplifier the sample let assume that your InnerJoin return from database a result set which contains:

            DataTable dt = new DataTable("Category");
            dt.Columns.Add("cCategoryID", typeof(int)); // Parent Key
            dt.Columns.Add("cCategoryName", typeof(string));
            dt.Columns.Add("cCategoryDesc", typeof(string));
            dt.Columns.Add("pCategoryID", typeof(int));
            dt.Columns.Add("pProductID", typeof(int));
            dt.Columns.Add("pProductName", typeof(string));

            

            // Let assume that after excute your query the result set contains this data
            // Please note that your inner join could return duplicate data from your first tabel Categories 
            dt.Rows.Add(0,"cCategoryName 0","cCategoryDesc 0", 0, 0, "pProductName 0");
            dt.Rows.Add(1, "cCategoryName 1", "cCategoryDesc 1", 1, 100, "pProductName 100");
            dt.Rows.Add(1, "cCategoryName 1", "cCategoryDesc 1", 1, 101, "pProductName 101");
            dt.Rows.Add(1, "cCategoryName 1", "cCategoryDesc 1", 1, 102, "pProductName 102");
            dt.Rows.Add(2, "cCategoryName 2", "cCategoryDesc 2", 2, 103, "pProductName 103");
            dt.Rows.Add(3, "cCategoryName 3", "cCategoryDesc 3", 3, 104, "pProductName 104");
            dt.Rows.Add(4, "cCategoryName 4", "cCategoryDesc 4", 4, 105, "pProductName 105");


            ds.Tables.Add(dt);
            DataRelation dr = new DataRelation("RR", dt.Columns["cCategoryID"], dt.Columns["pCategoryID"], false); // Set the constraints to False, because we have duplicate rows from the inner join 
            ds.Relations.Add(dr);

            ultraTree1.DataSource = ds.Tables[0];
        }

        private void ultraTree1_InitializeDataNode(object sender, Infragistics.Win.UltraWinTree.InitializeDataNodeEventArgs e)
        {
            
            if (e.Node.Level == 0 && OldValue != e.Node.Cells["cCategoryID"].Text)
            {
                e.Node.Cells["cCategoryID"].Column.Visible = true;
                e.Node.Cells["cCategoryName"].Column.Visible = true;
                e.Node.Cells["cCategoryDesc"].Column.Visible = true;

                e.Node.Cells["pCategoryID"].Column.Visible = false;
                e.Node.Cells["pProductName"].Column.Visible = false;
                e.Node.Cells["pProductID"].Column.Visible = false;

                e.Node.Visible = true;
            }
            else if (e.Node.Level == 1)
            {
                e.Node.Cells["cCategoryID"].Column.Visible = false;
                e.Node.Cells["cCategoryName"].Column.Visible = false;
                e.Node.Cells["cCategoryDesc"].Column.Visible = false;

                e.Node.Cells["pCategoryID"].Column.Visible = false;
                e.Node.Cells["pProductName"].Column.Visible = true;
                e.Node.Cells["pProductID"].Column.Visible = true;
            }

            else e.Node.Visible = false;
            OldValue = e.Node.Cells["cCategoryID"].Text;
        }
    }
}
